/*
 * Entagged Audio Tag library
 * Copyright (c) 2003-2005 Rapha�l Slinckx <raphael@slinckx.net>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package org.jaudiotagger.audio.wav;

import org.jaudiotagger.audio.AudioFile;
import org.jaudiotagger.audio.MyRandomAccessFile;
import org.jaudiotagger.audio.exceptions.CannotWriteException;
import org.jaudiotagger.audio.generic.AudioFileWriter;
import org.jaudiotagger.tag.Tag;

import java.io.RandomAccessFile;

public class WavFileWriter extends AudioFileWriter
{
   @Override
    protected void writeTag(AudioFile audioFile, Tag tag, MyRandomAccessFile raf, MyRandomAccessFile tempRaf) throws CannotWriteException
    {
        new WavTagWriter("UNKNOWN").write(tag, raf);
    }

    @Override
    protected void deleteTag(Tag tag, MyRandomAccessFile raf, MyRandomAccessFile tempRaf) throws CannotWriteException
    {
        new WavTagWriter("UNKNOWN").delete(tag, raf);
    }
}